require "rake"

shared_context "rake" do
  let(:rake)      { Rake::Application.new }
  let(:task_name) { self.class.top_level_description }
  let(:task_path) { "lib/tasks/#{task_name.split(":").first}" }

  subject         { rake[task_name] }

  def loaded_files_excluding_current_rake_file
    $".reject {|file| file == File.absolute_path("#{task_path}.rake").to_s }
  end

  before do
    Rake.application = rake
    Rake.application.rake_require(task_path, [Rake.application.original_dir], loaded_files_excluding_current_rake_file)
    Rake::Task.define_task(:environment)
  end
end